package oop2visuals;

import processing.core.PApplet;
import oop2visuals.Drawable;

public class House implements Drawable{

	Basement base;
	
	public House (Basement b) {
		base = b;
	}

	@Override
	public void draw(PApplet canvas, float posX, float posY) {
		canvas.stroke(0, 0, 0);
		base.draw(canvas, posX, posY);
	}
	
	
}

// a base for our house
class Basement implements Drawable {
	
	float width = 20;
	float height = 1;
	int colourR = 10, colourG = 10, colourB = 10;
	
	@Override
	public void draw(PApplet canvas, float posX, float posY) {
		canvas.fill(this.colourR, this.colourG, this.colourB);
		canvas.rect( posX
				   , posY - scale*this.height
				   , scale*this.width
				   , scale*this.height);
	}
	
	
}