package oop2visuals;

import processing.core.PApplet;
import oop2visuals.Drawable;

public class House implements Drawable{

	Basement base;
	Storey[] storeys;
	
	public House (Basement b, Storey[] ss) {
		base = b;
		storeys = ss;
	}

	@Override
	public void draw(PApplet canvas, float posX, float posY) {
		canvas.stroke(0, 0, 0);
		float h = posY;
		base.draw(canvas, posX, h);
		h -= base.height*scale;
		for (int i = 0; i < storeys.length; i++){
			storeys[i].draw(canvas, posX, h);
			h -= storeys[i].height*scale;
		}
	}
	
	
}

// a base for our house
class Basement implements Drawable {
	
	float width = 20;
	float height = 1;
	int colourR = 10, colourG = 10, colourB = 10;
	
	@Override
	public void draw(PApplet canvas, float posX, float posY) {
		canvas.fill(this.colourR, this.colourG, this.colourB);
		canvas.rect( posX
				   , posY - scale*this.height
				   , scale*this.width
				   , scale*this.height);
	}
	
	
}

// a single floor
class Storey implements Drawable{
	float width = 20;
	float height = 3;
	int colourR = 180, colourG = 80, colourB = 10;
	
	@Override
	public void draw(PApplet canvas, float posX, float posY) {
		// setup color
		canvas.fill(this.colourR, this.colourG, this.colourB);
		// draw floor
		canvas.rect( posX
				   , posY - scale*this.height
				   , scale*this.width
				   , scale*this.height);
		// set window color
		canvas.fill(188, 188, 211);
		// draw windows
		for (int i = 0; i < numberOfWindows(); i++) {
			canvas.rect( posX + scale*((2+windowSeperator())*i + windowSeperator()*0.5f)
					   , posY - scale*this.height*0.8f
					   , scale*2
					   , scale*this.height*0.5f);
		}
	}
	
	int numberOfWindows() { 
		return Math.round((float)Math.floor(this.width / 3));
	}
	
	float windowSeperator() {
		return (this.width - numberOfWindows()*2) / numberOfWindows();
	}
}