package oop2visuals;

import processing.core.PApplet;

public class Human implements Drawable {

	public enum State { AT_HOME, AT_OFFICE, GOING_HOME, GOING_TO_OFFICE}
	public State state = State.GOING_HOME;
	public float stateT = 0;
	public float roadTime = 5, homeTime = 10, workTime = 8;
	
	
	@Override
	public void draw(PApplet canvas, float posX, float posY) {
		float maxX = (float) canvas.width + scale*5;
		updateState(canvas);
		// render! (only on the road)
		switch (this.state) {
			case AT_HOME:
				break;
			case AT_OFFICE:
				break;
			case GOING_TO_OFFICE:
				drawMe(canvas, posX + (maxX - posX)*this.stateT, posY);
				break;
			case GOING_HOME:
				drawMe(canvas, posX + (maxX - posX)*(1f - this.stateT), posY);
				break;
		}
	}

	// Nothing new - just draw a human
	void drawMe(PApplet canvas, float posX, float posY) {
		canvas.fill(30, 30, 30);
		canvas.ellipse( posX
				      , posY - scale*1.5f
					  , scale*0.9f, scale*1.3f);
		canvas.stroke(0, 0, 90);
		canvas.line(posX + scale*0.2f, posY - scale*1f, posX + scale*0.4f, posY + scale*0.3f);
		canvas.line(posX - scale*0.2f, posY - scale*1f, posX - scale*0.4f, posY + scale*0.3f);
		canvas.line(posX + scale*0.2f, posY - scale*2.1f, posX + scale*0.9f, posY - scale*0.8f);
		canvas.line(posX - scale*0.2f, posY - scale*2.1f, posX - scale*0.9f, posY - scale*0.8f);
		canvas.fill(90, 0, 0);
		canvas.ellipse( posX
				      , posY - scale*2.3f
					  , scale*0.5f, scale*0.6f);
		
	}

	// update internal state of a human
	void updateState(PApplet canvas){
		// update state timer
		switch (this.state) {
		case GOING_HOME:
			this.stateT += 1f/canvas.frameRate/this.roadTime;
			break;
		case GOING_TO_OFFICE:
			this.stateT += 1f/canvas.frameRate/this.roadTime;
			break;
		case AT_HOME:
			this.stateT += 1f/canvas.frameRate/this.homeTime;
			break;
		case AT_OFFICE:
			this.stateT += 1f/canvas.frameRate/this.workTime;
			break;
		default:
			break;
		}
		// change state if needed
		if(this.stateT >= 1)
		{
			this.stateT = 0;
			switch (this.state) {
			case GOING_HOME:
				this.state = State.AT_HOME;
				break;
			case GOING_TO_OFFICE:
				this.state = State.AT_OFFICE;
				break;
			case AT_HOME:
				this.state = State.GOING_TO_OFFICE;
				break;
			case AT_OFFICE:
				this.state = State.GOING_HOME;
				break;
			default:
				break;
			}
			
		}
	}

	
}
